<?php
/***************************************************************************
 phpTrafficA @soft.ZoneO.net
 Copyright (C) 2004-2008 ZoneO-soft, Butchu (email: "butchu" with the domain "zoneo.net")

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 More Info About The Licence At http://www.gnu.org/copyleft/gpl.html
****************************************************************************/
include ("../Php/config_sql.php");
include ("../Php/config.php");
?>
<html>
<title>Welcome to phpTrafficA</title>
<meta http-equiv="content-type" content="text/html; charset=UTF-8">
<META NAME="AUTHOR" CONTENT="phpTrafficA">
<link rel="stylesheet" href="install.css" type="text/css">
</head>
<body>
<div id="main">
<h1>Upgrading phpTrafficA - step 1</h1>
<?php

function diehere($error, $extra="") {
	$txt = "<div class=\"error\">\n$error\n";
	if ($extra != "") $txt .= "<br>&nbsp;<br>$extra\n";
	$txt .= "</div>\n<b>Upgrade failed</b></div>\n</body>\n</html>\n";
	@mysql_close ($c);
	die($txt);
}

// ****************************************************************************
// 0- Testing connection to database
// ****************************************************************************
echo "\n<P><b>Database</b>";
echo "<br>Connecting to database server. User is <code>$user</code> and server is <code>$server</code>.";
$c = @mysql_connect("$server","$user","$password") or diehere("Can not connect to database in install.php:<br>".mysql_error());
echo " <font color='#35BA4D'>Ok</font>";
echo "<br>Selecting base defined in config_sql.php: <code>$base</code>.";
$db = @mysql_select_db("$base",$c) or diehere("Can not select base in install.php:<br>".mysql_error());
echo " <font color='#35BA4D'>Ok</font>";
echo "<br>Retrieve the MySQL server version: ";
$mysql_version = mysql_get_server_info();
$pos = strpos($mysql_version, '.');
$pos = strpos($mysql_version, '.',$pos+1);
$mysql_version_major = substr($mysql_version, 0, $pos);
echo "$mysql_version\n";
if ($mysql_version_major < 4.2) {
	$engine_or_type = "TYPE";
} else {
	$engine_or_type = "ENGINE";
}

// ****************************************************************************
// 1- Read and write permission to sites.php or database table with site list
// ****************************************************************************
echo "<P><b>Testing access to site list</b><br>Checking write and read permissions to file sites.php\n";
$ok = true;
$sitesInTable = false;
echo "<br>- Access to file: ";
if (is_file('sites.php')) { 
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
	$ok = false;
}
echo "<br>- Reading file: ";
if (is_readable('sites.php')) { 
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
	$ok = false;
}
echo "\n<br>- Writing file: ";
if (is_writable('sites.php')) { 
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
	$ok = false;
}
echo "<br>Testing database for sites information: <code>${config_table}_sites</code> ";
$sql = @mysql_query("show table status like '${config_table}_sites'",$c) or diehere("Error with database at line ".__LINE__.": ".mysql_error());
$table_exists = mysql_num_rows($sql) == 1;
if ($table_exists) {
	$ok = true;
	$sitesInTable = true;
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
}
if (!$ok) {
	diehere("Can not find sites information.<br>- If upgrading from a version of phpTrafficA older than 2.0, copy the file <code>sites.php</code> from a previous installation to the <code>Install/</code> directory.<br>- Otherwise, make sure that the <code>\$config_table</code> variable in <code>config.php</code> is set properly.");
}

// ****************************************************************************
// 2- Filesystem test
// ****************************************************************************
echo "\n<P><b>Filesystem test</b>";
$path =  __FILE__;
$path = preg_replace( "'\\\upgrade\.php'", "", $path);
$path = preg_replace( "'/upgrade\.php'", "", $path);
$path = "$path/../$tmpdirectory";
echo "\n<br>Path for temporary files: <code>$path</code>";
echo "\n<br>Testing creation of a temporary file in tmp directory: ";
$file = "$path/test.txt";
if (@touch($file)) {
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
	$ok = false;
}
echo "\n<br>Trying to delete the file that was just created: ";
if (@unlink($file)) {
	echo "<font color='#35BA4D'>Ok</font>";
} else {
	echo "<font color='#FF0000'>Failed</font>";
	$ok = false;
}
echo "\n<br>End of file system test. Status: ";
if ($ok) {
	echo "<font color='#35BA4D'>Pass</font>.";
} else {
	echo "<font color='#FF0000'>Failed</font>.";
}
if (!$ok) {
	diehere ("\nThere was an error in the filesystem test. The upgrade will stop here. Refer to <a href=\"http://soft.ZoneO.net/phpTrafficA\">phpTrafficA homepage</a> for more information.");
}

// ****************************************************************************
// 4- Upgrades based on sites.php
// ****************************************************************************
if (!$sitesInTable) {
	// If the SQL table with sites does not exist, we have an upgrade
	// from a version older than 2.0. We run a specific upgrade based
	// on the file 'sites.php'
	include('upgradeSites.php');
}

// ****************************************************************************
// 5- Adding new parameters to configuration table
// ****************************************************************************
include ("./confDB.sql.php");
echo "<P><b>Upgrading configuration table.</b>\n";
$doit = "SELECT * FROM $config_table";
if (!mysql_query($doit,$c))
	diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
$res = mysql_query($doit,$c);
$config = array("x" =>"x");
while($row = mysql_fetch_array($res)) {
	$config = $config + array($row["variable"] => $row["value"] );
}
mysql_free_result ($res);
if (!isset($config["ntop"])) {
	echo "<br>- Inserting <code>ntop</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('ntop', '$ntop')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
if (!isset($config["ntoplong"])) {
	echo "<br>- Inserting <code>ntoplong</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('ntoplong', '$ntoplong')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
if (!isset($config["seref"])) {
	echo "<br>- Inserting <code>seref</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('seref', '$seref')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
if (!isset($config["visitcutoff"])) {
	echo "<br>- Inserting <code>visitcutoff</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('visitcutoff', '$visitcutoff')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
if (!isset($config["stringLengthsFactor"])) {
	echo "<br>- Inserting <code>stringLengthsFactor</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('stringLengthsFactor', '$stringLengthsFactor')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
if (!isset($config["version"])) {
	echo "<br>- Inserting <code>version</code> parameter.\n";
	$doit = "INSERT INTO $config_table VALUES ('version', '$version')";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
} else {
	echo "<br>- Updating <code>version</code> parameter.\n";
	$doit = "UPDATE $config_table SET value='$version' WHERE variable='version'";
	if (!mysql_query($doit,$c)) diehere("Error with database at line ".__LINE__.": ".mysql_error(), "Was working on $doit.");
}
echo "<br><font color='#35BA4D'>Done</font>.\n";

// ****************************************************************************
// 6- Makeing sure that table for IPBan is available
// ****************************************************************************

echo "<P><b>IP ban table.</b>\n";
echo "<br>Testing database for ip ban information: <code>${config_table}_ipban</code> ";
$sql = @mysql_query("show table status like '${config_table}_ipban'",$c) or diehere("Error with database at line ".__LINE__.": ".mysql_error());
$table_exists = mysql_num_rows($sql) == 1;
if ($table_exists) {
	echo "<font color='#35BA4D'>Ok</font>.\n";
} else {
	echo "<font color='#FF0000'>Failed</font>.\n";
	echo "<br>Creating missing table ";
	$doit = $sqlCreateIPBan;
	if (!mysql_query($doit,$c))
		diehere("Error with database at line ".__LINE__.": ".mysql_error(), "<br>Was working on $doit.");
	echo "<font color='#35BA4D'>Ok</font>.\n";
}

@mysql_close ($c);

// ****************************************************************************
// 7- Upgrade of browser and search engine list
// ****************************************************************************
?>
<FORM action="upgrade2.php" method="POST">
<table border="0" align="center">
<tr><td><INPUT type="checkbox" checked name="upgradeOS" value="upgradeOS"></td><td>Upgrade list of operating systems</td></tr>
<tr><td><INPUT type="checkbox" checked name="upgradeWB" value="upgradeWB"></td><td>Upgrade list of web browsers</td></tr>
<tr><td><INPUT type="checkbox" checked name="upgradeSE" value="upgradeSE"></td><td>Upgrade list of search engines</td></tr>
<tr><td colspan="2" align="center"><INPUT type="submit" value="Proceed"></td></tr>
</table>
</FORM>
</div>
</body>
</html>